#include <windows.h>

#include <Outpost2DLL.h>
#include <OP2Helper.h>
#include <hfl.h>
#include "OP2Types\OP2Types.h"

#include "odprintf.h"

#include "Patcher.h"
#include "ExtLocation.h"
#include "MessageHook.h"

// **
// Set these
// **
bool acidTest = true;		 	// Adds scorpions to fightgroups, causing the game to trip acid
int numWaves = 71,				// Number of passes/waves of scorpions to spawn. 0 = no limit
	numPerWave = 176,			// Number of scorpions per wave. Values above ~250-256 will not work.
	timeBetweenWaves = 50;		// Ticks between waves (100 ticks = 1 mark) (swarm = 2400 ticks between waves?) Setting this too low
								//  will cause the free unit array bug (50 is safe, 25 is unsafe, todo: test for exact value)

int numBreakWaves = 0,			// 0 = Skip causing free unit array bug, 1+ = # of passes of scorpions to spawn to cause bug
	numPerBreakWave = 160;		// Number of scorpions per "breaking" wave (needs to be less than numPerWave). When bug manifests,
								//  only (numPerWave - numPerBreakWave) scorpions will spawn.

// Results/time to acid trip are bizarrely unique for each unit type and move speed, size of guardRect, and spawn location?
map_id unitToSpawn = mapScorpion;
int moveSpeed = -2;				// -2 = skip, 0+ = change unit's speed. 0 will never acid trip, 1 takes longest time to cause it, then less time with 2, and so on
bool shootAtSelf = false;
LOCATION spawnLoc = LOCATION(42, 47);
MAP_RECT guardRect = MAP_RECT(MapLocation(1,12), MapLocation(64,63));

// **
// Notes:
// (All of these notes were taken with 1 scorpion spawned per wave, 25 ticks between waves, no wave limit, no free unit break waves)
// If tileset data gets overwritten, it should begin happening after 2048 (1024*2) units have been created (all time), then crash
// Crashing after overwriting all tileset data happens after 6144 (1024*6) units have been created (all time)
// If map data gets overwritten, crash happens after 3072 (1024*3) units have been created (all time)
// If overwriting other areas, crashing happens randomly
// **

char MapName[]		= "Swarm.map";				// The .map file used for this level
char LevelDesc[]		= "Electric Kool-Aid Acid Test";      // Description appearing in the game list box
char TechtreeName[]	= "MULTITEK.TXT";			// File to use for the tech tree
SDescBlock DescBlock	= { Colony, 2, 12, 0 };     // Important level details

FightGroup acidTestGroup[8];
int scorpsAlive = 0, // Independently-tracked counter, currently unused
	spawnedWaves = 0; // Total scorpion waves ever created
UINT totalScorpsCreated = 0; // Total scorpions ever created

struct LOL
{
	static int __thiscall DoStuffUnknown(void* classPtr);
	static int __thiscall Patrolz(void* classPtr, int numWaypoints, short unk, void* wayPoints);
};


BOOL APIENTRY DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH)
	{
		DisableThreadLibraryCalls(hinstDLL);
		
		if (HFLInit() == HFLCANTINIT
			|| !(superSpeed = Patcher::Patch<unsigned char>((void*)OP2Addr(0x49C374), 0xEB, 0x73, false)) // super speed
			|| !Patcher::Patch<void*>((void*)OP2Addr(0x4CFF34), &LOL::DoStuffUnknown, false) // replace acid trip causing vfunction?
			//|| !Patcher::PatchFunctionCall((void*)OP2Addr(0x428746), &LOL::Patrolz, false) // replace IssuePatrol call in above func
			|| !SetMessageHook()
			)
		{
			Patcher::DoUnpatchAll(true);
			HFLCleanup();
			return FALSE;
		}
	}
	else if (fdwReason == DLL_PROCESS_DETACH)
	{
		Patcher::DoUnpatchAll(true);
		HFLCleanup();
	}

    return TRUE;
}


ScGroup CreateScGroup(_Player owner)
{
	int* (__thiscall *ScStubCreator_CreateScStub)(void* scStubCreatorInfo) = (int* (__thiscall*)(void*))OP2Addr(0x47B410);

	ScGroup returnedGroup = ScGroup();
	int* internalObj = ScStubCreator_CreateScStub((void*)OP2Addr(0x4E0B60));
	internalObj[189] = owner.playerNum;
	returnedGroup.ID = internalObj[1];

	return returnedGroup;
}

int __thiscall LOL::DoStuffUnknown(void *classPtr)
{
	int (__thiscall *RealDoStuffUnknown)(void*) = (int (__thiscall*)(void*))OP2Addr(0x4286D0);

	//odprintf("about to call virtual func");
	int result = RealDoStuffUnknown(classPtr);
	//odprintf("virt func called");
	return result;
}
int __thiscall LOL::Patrolz(void* classPtr, int numWaypoints, short unk, void *wayPoints)
{
	int (__thiscall *Unit_IssuePatrol)(void*,int,short,void *waypoints)
		= (int (__thiscall*)(void*,int,short,void *waypoints))OP2Addr(0x42A740);
	//odprintf("about to patrol");
	int result = Unit_IssuePatrol(classPtr, numWaypoints, unk, wayPoints);
	//odprintf("patrol");
	return result;
}


//const int size = 0x56E40;
//char newGraphics[size];
UnitEx scorpz;
int InitProc()
{
	/*DWORD oldProtection;
	//newGraphics = new char[sizeof(OP2Graphics)];
	if (!VirtualProtect(graphicsObj, size, PAGE_READWRITE, &oldProtection)
		|| memcpy(&newGraphics, graphicsObj, size) < (void*)0
		|| !VirtualProtect(graphicsObj, size, oldProtection, &oldProtection)
		|| !Patcher::PatchGlobalReferences(graphicsObj, &newGraphics, false))
		return 0;*/

	Unit unit;
	//TethysGame::CreateUnit(unit, mapGuardPost, MapLocation(62,62), 0, mapAcidCloud, 0);
	unitInfoArray[mapGuardPost]->playerData[0].hitPoints = 65535;

	Player[1].GoAI();
	Player[1].SetTechLevel(13);
	if (shootAtSelf)
	{
		unitInfoArray[unitToSpawn]->playerData[1].hitPoints = 65535;
		Player[1].AllyWith(1);
	}
	Player[TethysGame::LocalPlayer()].CenterViewOn(SplitLoc(MapLocation(438, 195)));

    TethysGame::ForceMoraleGreat(-1);
	if (moveSpeed >= 0)
		unitInfoArray[unitToSpawn]->playerData[1].moveSpeed = moveSpeed;

    for (int i = 0; i < (sizeof(acidTestGroup) / sizeof(acidTestGroup[0])); ++i)
	{
		acidTestGroup[i] = CreateFightGroup(1);
		acidTestGroup[i].AddGuardedRect(guardRect);
	}

	CreateTimeTrigger(TRUE, FALSE, timeBetweenWaves, "KillScorps");

	TethysGame::SetDaylightMoves(FALSE);

	SongIds playlist[] = {
		songEP51,
		songEP52,
		songPlymth11,
		songPlymth12
	};
	TethysGame::SetMusicPlayList(8, 1, playlist);

	return 1; // return 1 if OK; 0 on failure
}

SCRIPT_API void KillScorps()
{
	//acidTestGroup[0].RemoveUnit(scorpz);
	//return; //**

	UnitEx unit;
	PlayerVehicleEnum scorpEnum(1);
	OP2Unit *internalUnit;
	while
		(scorpEnum.GetNext(unit))
	{
	//for (unit.unitID = 0; unit.unitID < ((OP2Map*)mapObj)->lastUsedUnitIndex; ++unit.unitID)
	//{
		if (!unit.IsLive())
			continue;
		if (unit.GetType() == unitToSpawn)
		{
			internalUnit = &(*unitArray)[unit.unitID];
			--scorpsAlive;

			if (shootAtSelf)
			{
				int (__thiscall *Unit_DoDeath)(OP2Unit *classPtr, char startAnimIndex)
					= (int (__thiscall *)(OP2Unit*,char))OP2Addr(0x43A990);
			
				unit.SetDamage(unit.GetUnitInfo().GetHitPoints(3));
				internalUnit->flags |= UNIT_ISDEAD;
				Unit_DoDeath(internalUnit, 1);
			}
			else
				unit.DoPoof();
		}
	}
}

void SpawnScorps(int num = 1)
{
	OP2Unit* (__thiscall *Sheet_CreateMapUnit)(void *classPtr, int unitType, int pixelX, int pixelY, int creatorId, int cargoWeapon,
		int unitIndex, int centerInTile) = (OP2Unit* (__thiscall *)(void*,int,int,int,int,int,int,int))_OP2Addr(0x4467C0);

	int (__thiscall *Unit_IssuePatrol)(void*,int,short,void*)
		= (int (__thiscall*)(void*,int,short,void*))OP2Addr(0x42A740);
	DestWaypoints::Waypoint lolpoints[2];
	MapLocation loc1 = MapLocation(1, 1).ToPixels(), loc2 = MapLocation(25, 25).ToPixels();
	lolpoints[0].pixelX = loc1.x, lolpoints[0].pixelY = loc1.y,
		lolpoints[1].pixelX = loc2.x, lolpoints[1].pixelY = loc2.y;

	OP2Unit *internalUnit;

	UnitEx unit;
	int group = 0, numCreated = 0, createdTot = 0, x = 0, y = 0;
	for (UINT i = 0; i < min(num, 32 * (sizeof(acidTestGroup) / sizeof(acidTestGroup[0]))); ++i, ++x)
	{
		if (x == 18)
		{
			x = 0;
			++y;
		}
		if (numCreated == 32)
		{
			++group;
			numCreated = 0;
		}
		if ((internalUnit = Sheet_CreateMapUnit(unitInfoObj, unitToSpawn, SplitLoc(MapLocation(spawnLoc.x + x, spawnLoc.y + y).ToPixels()), 1, (unitToSpawn >= mapScorpion && unitToSpawn <= mapTiger) ? mapRPG : mapNone, 0, 1)))
			//TethysGame::CreateUnit(unit, unitToSpawn, MapLocation(438 + x, 195 + y), 1, weaponToSpawn, 0)) can crash if failed to create unit (it will try to set direction anyway)
		{
			unit.unitID = internalUnit->unitIndex;
			if (acidTest == true)
				acidTestGroup[group].TakeUnit(unit); // Causes acid trip
			else
				unit.DoMove(MapLocation(1, 1)); // Doesn't cause acid trip(?)
			//Unit_IssuePatrol(internalUnit, 2, 0, lolpoints);
			++numCreated, ++scorpsAlive, ++totalScorpsCreated;
		}
	}
	if ((createdTot = numCreated + (32 * group)))
	{
		++spawnedWaves;
		odprintf("%i/%i scorps created | %i all time", createdTot, num, totalScorpsCreated);
	}
}

void AIProc()
{
	// code for fucking up the free unit array
	UnitEx unit;
	static int spawnedInitialScorps = 0, killedInitialScorps = 0;
	int curScorps = 0, i = 0;

	PlayerVehicleEnum scorpEnum(1);
	while (scorpEnum.GetNext(unit))										// Count number of scorpions currently alive
	{
		if (unit.IsLive() && unit.GetType() == unitToSpawn)
			++curScorps;
	}

	//odprintf("scorps ever made: %i | cur scorps alive: %i | cur scorps alive (alt): %i", totalScorpsCreated, curScorps, scorpsAlive);
	
	if (killedInitialScorps < numBreakWaves && curScorps > 0)			// Kill init breaking wave
	{
		KillScorps();
		++killedInitialScorps;
	}
	if (spawnedInitialScorps < numBreakWaves)							// Spawn init breaking wave
	{
		SpawnScorps(numPerBreakWave);
		++spawnedInitialScorps;
	}
	else if ((!numWaves || spawnedWaves < numWaves) && curScorps == 0)	// Spawn regular waves
		SpawnScorps(numPerWave);
	else if (spawnedWaves == numWaves)
	{
		TethysGame::SetDaylightEverywhere(FALSE);
		TethysGame::SetDaylightMoves(TRUE);
		TethysGameEx::ResetCheatedGame();
		++spawnedWaves;
	}

	//char orgy[0x32];
	//scr_snprintf(orgy, sizeof(orgy), "You are awarded %i common ore and %i rare ore.", 9001, 9001);
	//TethysGame::AddMessage(-1, -1, orgy, -1, 0);
}

void __cdecl GetSaveRegions(struct BufferDesc &bufDesc)
{
	bufDesc.bufferStart = 0;	// Pointer to a buffer that needs to be saved
	bufDesc.length = 0;			// sizeof(buffer)
}

int StatusProc()
{
	return 0; // must return 0
}

SCRIPT_API void NoResponseToTrigger()
{
}


