

#include <windows.h>
#include <Outpost2DLL.h>
#include <OP2Helper.h>
#include <hfl.h>
#include "OP2Types\OP2Game.h"
#include "odprintf.h"

#include "Patcher.h"

_Patch *superSpeed = NULL;

extern bool acidTest;
extern int numWaves, numPerWave, timeBetweenWaves, numBreakWaves, numPerBreakWave, moveSpeed;
extern map_id unitToSpawn;

bool needsInput = false; // todo: implement


void CheckChatMessage(char* chatText, int sourcePlayerNum)
{
	// Max length of chat string
	const int size = 36 + 1;
	
	if (!chatText || chatText[0] != '/')
		return;

	// Tokenize chat string
	int i = 0;
	char buf[size];
	strcpy_s(buf, sizeof(buf), chatText);
	char word[10][size], *ptok = NULL, *pch = strtok_s(buf, " /", &ptok);
	do
	{
		strcpy_s(word[i], sizeof(word[0]), pch);
		++i;
	} while ((pch = strtok_s(NULL, " ", &ptok)) != 0 && i < (sizeof(word) / sizeof(word[0])));
	
	// Begin command checks
	if (strcmp(word[0], "superspeed") == 0)
	{
		if (superSpeed)
		{
			if (strcmp(word[1], "on") == 0
				&& superSpeed->Patch())
			{
				((OP2Game*)gameObj)->gameSpeedx4 = 20 * 4;
				strcpy_s(chatText, size, "Super speed activated");
			}
			else if (strcmp(word[1], "off") == 0
				&& superSpeed->Unpatch(false))
			{
				((OP2Game*)gameObj)->gameSpeedx4 = 10 * 4;
				strcpy_s(chatText, size, "Super speed deactivated");
			}
		}
	}
	else if (strcmp(word[0], "daynightmoves") == 0)
	{
		if (strcmp(word[1], "on") == 0)
		{
			TethysGame::SetDaylightMoves(TRUE);
			TethysGameEx::ResetCheatedGame();
			strcpy_s(chatText, size, "Day/night movement activated");
		}
		else if (strcmp(word[1], "off") == 0)
		{
			TethysGame::SetDaylightMoves(FALSE);
			TethysGameEx::ResetCheatedGame();
			strcpy_s(chatText, size, "Day/night movement deactivated");
		}
	}
	else if (strcmp(word[0], "daynight") == 0)
	{
		if (strcmp(word[1], "on") == 0)
		{
			TethysGame::SetDaylightEverywhere(FALSE);
			strcpy_s(chatText, size, "Day/night cycle activated");
		}
		else if (strcmp(word[1], "off") == 0)
		{
			TethysGame::SetDaylightEverywhere(TRUE);
			strcpy_s(chatText, size, "Daylight everywhere activated");
		}
	}
}


bool SetMessageHook(bool setting)
{
	static _Patch *messageHook = NULL;

	if (setting)
	{
		if (!messageHook && !(messageHook =	Patcher::PatchFunctionCall((void*)OP2Addr(0x40FD85), &CheckChatMessage, false)))
			return false;
		if (numWaves == -1 || numPerWave == -1 || timeBetweenWaves == -1 || numBreakWaves == -1 || numPerBreakWave == -1
			|| moveSpeed == -1 || unitToSpawn == (map_id)-1)
			needsInput = true;
	}
	else if (messageHook)
	{
		messageHook->Unpatch(true);
		messageHook = NULL;
	}

	return true;
}